//---------------------------------------------------------------------------


#pragma hdrstop
#include "ChatContextData.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)
TChatContextData *ChatContextData;
//---------------------------------------------------------------------------
void __fastcall TChatContextData::CheckForMsg(void)
{
  AnsiString UN, msg;
  if(FCurMsg->Count > 1)
  {
    if(UserName == "")
    {
      UN = Pop();
      if(FOnUserNameSet != NULL)
        FOnUserNameSet(this, UN);
      UserName = UN;
      msg = "Welcome " + UN + char(13) + char(10);
      Context->Connection->IOHandler->WriteLn(msg);
    }
    else
    {
      if(FOnMsgAvail != NULL)
        FOnMsgAvail(this);
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TChatContextData::CheckMsg(Idcontext::TIdContext* AContext)
{
  AnsiString S, Swp;
  int I;
  FLock->Enter();
  try
  {
    FContext = AContext;
    AContext->Connection->IOHandler->CheckForDisconnect(true, true);
    I = AContext->Connection->IOHandler->RecvBufferSize;
    if(I >= 1)
    {
      Swp = FCurMsg->Text.SubString(1, FCurMsg->Text.Length()-2);
      //SetLength(S, I);
      AContext->Connection->IOHandler->ReadString(I);
      S = StringReplace(S, char(13)+char(10), char(10)+char(13), TReplaceFlags() << rfReplaceAll);
      if(S == char(10)+char(13))
      {
        FCurMsg->Add("");
      }
      else
      {
        FCurMsg->Text = Swp + S;
      }
      CheckForMsg();
    }
  }
  __finally
  {
    FLock->Leave();
  }
}
//---------------------------------------------------------------------------
__fastcall TChatContextData::TChatContextData(void)
{
  FCurMsg = new TStringList;
  FLock = new TCriticalSection;
}
//---------------------------------------------------------------------------
__fastcall TChatContextData::~TChatContextData(void)
{
  delete FCurMsg;
  delete FLock;
}
//---------------------------------------------------------------------------
Idcontext::TIdContext* __fastcall TChatContextData::GetContext(void)
{
  return FContext;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TChatContextData::GetCurMsg()
{
  AnsiString sResult = "";
  FLock->Enter();
  try
  {
    if(FCurMsg->Count > 0)
    {
      sResult = FCurMsg->Strings[0];
    }
    else
    {
      sResult = "";
    }
  }
  __finally
  {
    FLock->Leave();
  }
  return sResult;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TChatContextData::Pop()
{
  AnsiString sResult;
  FLock->Enter();
  try
  {
    sResult = GetCurMsg();
    if(UserName != "")
    {
      sResult = UserName + ": " + sResult;
    }
    if(FCurMsg->Count > 0)
    {
      FCurMsg->Delete(0);
    }
  }
  __finally
  {
    FLock->Leave();
  }
  return sResult;
}
//---------------------------------------------------------------------------
void __fastcall TChatContextData::SetOnMsgAvail(const TMsgAvail Value)
{
  FOnMsgAvail = Value;
}
//---------------------------------------------------------------------------
void __fastcall TChatContextData::SetOnUserNameSet(const TUserNameSet Value)
{
  FOnUserNameSet = Value;
}
//---------------------------------------------------------------------------
void __fastcall TChatContextData::SetUserName(const AnsiString Value)
{
  FUserName = Value;
}


