//---------------------------------------------------------------------------

#ifndef ChatContextDataH
#define ChatContextDataH

//---------------------------------------------------------------------------
#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <vcl>
#include <IdGlobal.hpp>	// Pascal unit
#include <IdContext.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <SyncObjs.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Chatcontextdata
{
//-- type declarations -------------------------------------------------------
class TChatContextData;
typedef void __fastcall (__closure *TMsgAvail)(TChatContextData* Sender);

typedef void __fastcall (__closure *TUserNameSet)(TChatContextData* Sender,
                                                  AnsiString &UserName);

class TChatContextData : public System::TObject
{
	typedef System::TObject inherited;

private:
	Syncobjs::TCriticalSection* FLock;
	Classes::TStringList* FCurMsg;
	TMsgAvail FOnMsgAvail;
	Idcontext::TIdContext* FContext;
	AnsiString FUserName;
	TUserNameSet FOnUserNameSet;
	AnsiString __fastcall GetCurMsg();
	void __fastcall CheckForMsg(void);
	void __fastcall SetOnMsgAvail(const TMsgAvail Value);
	Idcontext::TIdContext* __fastcall GetContext(void);
	void __fastcall SetUserName(const AnsiString Value);
	void __fastcall SetOnUserNameSet(const TUserNameSet Value);
	
public:
	__property AnsiString CurMsg = {read=GetCurMsg};
	AnsiString __fastcall Pop();
	__fastcall TChatContextData(void);
	__fastcall virtual ~TChatContextData(void);
	void __fastcall CheckMsg(Idcontext::TIdContext* AContext);
	__property TMsgAvail OnMsgAvail = {read=FOnMsgAvail, write=SetOnMsgAvail};
	__property Idcontext::TIdContext* Context = {read=GetContext};
	__property AnsiString UserName = {read=FUserName, write=SetUserName};
	__property TUserNameSet OnUserNameSet = {read=FOnUserNameSet, write=SetOnUserNameSet};
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Chatcontextdata */
using namespace Chatcontextdata;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif // ChatContextData
